//var ServiceURL = "http://skednet.cloudapp.net/wcf/SkednetService.svc/json/";
var ServiceURL = "https://secure.skednet.com/wcf/SkednetService.svc/json/";
//var ServiceURL = "http://bs-stbun.vcd.local/wcf/SkednetService.svc/json/";
//var ServiceURL = "http://172.16.21.217/wcf/SkednetService.svc/json/";

var LastAction = new Date();
var PGapLoaded = false;

function init() {
    console.log("init connector");
    //verifyLogin();
    document.addEventListener("deviceready", onDeviceReady, false);
}

function onDeviceReady() {
    console.log("DeviceReady Fired");
    PGapLoaded = true;
    StatusBar.hide();
    navigator.splashscreen.hide();
    verifyLogin();
}

function isOnline() { 
    if (!PGapLoaded) return false;
    return navigator.connection.type != "none";
}

function checkConnection() {
    var networkState = navigator.connection.type;

    var states = {};
    states[Connection.UNKNOWN]  = 'Unknown connection';
    states[Connection.ETHERNET] = 'Ethernet connection';
    states[Connection.WIFI]     = 'WiFi connection';
    states[Connection.CELL_2G]  = 'Cell 2G connection';
    states[Connection.CELL_3G]  = 'Cell 3G connection';
    states[Connection.CELL_4G]  = 'Cell 4G connection';
    states[Connection.CELL]     = 'Cell generic connection';
    states[Connection.NONE]     = 'No network connection';

    alert('Connection type: ' + states[networkState]);
}

/**
 * Make AJAX call to the webserivce.
 * @param method - name of WCF method to call
 * @param jsondata - JSON parameters to send
 * @param callback - function to call after finish
 */
function CallWCF(method, jsondata, callback) {
    console.log("callwcf" + method);
    if(!(navigator.onLine || isOnline())) {
        if($(":mobile-pagecontainer").pagecontainer("getActivePage").attr("id") == "login-page")
            hideLoading();
        else 
			$(":mobile-pagecontainer").pagecontainer("change", "login.html", { allowSamePageTransition: true });   
        
        //alert("Geen internetverbinding");
        showNotification("Geen internet", "Zorg voor een actieve Wi-Fi/3G verbinding");        
    }
    else {
        if((new Date() - LastAction) > 20*60*1000) {
            $(":mobile-pagecontainer").pagecontainer("change", "login.html", { allowSamePageTransition: true });   
            //alert("Sessie verstreken. Log opnieuw in");
            showNotification("Sessie verstreken", "Log opnieuw in");
            hideLoading();
        }    
        
        $.jsonp({
            url : ServiceURL + method,
            callbackParameter : "callback",
            data : jsondata,
            timeout : 60000,
            success : function(data, text) {
            //    console.log(method + " " + text + " " + callback);
            //    console.log(data);
                
                if(method == "GetScheduleAndFrqMobile")
                	eval(callback)(data, jsondata);
                else
                	eval(callback)(data);
            },
            error : function(request, status) {
                console.log(request);
                if(method == "GetScheduleAndFrqMobile") {
                    getScheduleFailed(status);
                }
                else
                    showNotification("Data ophalen mislukt", "Controleer internetverbinding en probeer opnieuw " + ServiceURL + method + " = " +request[0]); 
                  //  eval(callback)(null);
                  //  alert(method + " mislukt");
                    //CallWCF(method, jsondata, callback);
            }
        });
        
        LastAction = new Date();
    }
}

function getAppInfo() {
    $.ajax({
        type: "GET",
        url: "config.xml",
        dataType: "xml",
        success: function(xml) {
            var widget = $(xml).find("widget");
            var author = $(widget).find("author");
            var info = {
                version: widget.attr("version"),
                author: author.text(),
                url: author.attr("href"),
                email: author.attr("email")
            };
            showAppInfo(info);
        }
    });
}