var curColleague = "0";

$(document).on("pagecreate", "#colleagues-page", function(event) {
    loadColleagues();
});

function showColleague(id) {
	curColleague = id;	
	 $(":mobile-pagecontainer").pagecontainer("change", "colleague.html", { allowSamePageTransition: true,  transition: "slide" });    
}

function loadColleagues() {
    loadDiv('#colleagues-list', views + 'loading.html');
    buildColleaguesList();
}

function buildColleaguesList() {
    $('#colleagues-list li').remove();
    $.each(D.Employees, function(index, colleague) {
        addColleague(index, colleague);
    });
    $('#colleagues-list').listview('refresh');
}

function addColleague(index, colleague) {
    $('#colleagues-list').append('<li><a href="javascript:void(0);" onClick="showColleague(\'' + index + '\')">' + 
    colleague.EM_FirstName + ' ' + colleague.EM_LastName +'</a></li>');
}

/**
 * Called on opening a colleague profile
 */
$(document).on("pagebeforeshow", "#colleague-profile", function(event) {
    //var id = getUrlVars()["id"];
    var colleague = D.Employees[curColleague];
    var locationNumber = D.Location.LO_Number != undefined ? " (" + D.Location.LO_Number + ")" : "";
    
    $('#colleaguePic').attr('src', 'img/avatar.gif');
    $('#fullName').text(colleague.EM_FirstName + ' ' + colleague.EM_LastName);
    $('#companyName').text(D.Company);
    $('#locationName').text(D.Location.LO_Name + locationNumber);

    if (colleague.EM_Email) {
        addContactAction("mailto:", colleague.EM_Email, "E-mail", "mail.png");
    }
    if (colleague.EM_Phone) {
        addPhoneAction(colleague.EM_Phone);
    }
    if (colleague.EM_Mobile) {
        addPhoneAction(colleague.EM_Mobile);
    }
    $('#colleague-actionList').listview('refresh');
});

function addPhoneAction(phoneNumber) {
    phoneNumber = phoneNumber.replace("-", "");
    if(phoneNumber.length > 2 && phoneNumber.substr(0,2) == "06") {
        addContactAction("tel:", phoneNumber, "Bel mobiel", "mobile.png");      
        addContactAction("sms:", phoneNumber, "SMS", "sms.png");
    } else addContactAction("tel:", phoneNumber, "Bel vast", "phone.png");
}

/**
 * Add a new contact action (phone, mail, etc)
 * @param action - protocol to use
 * @param data - e.g. a phone number
 * @param title - action name to display
 * @param icon - icon img to represent action
 */
function addContactAction(action, data, title, icon) {
    $('#colleague-actionList').append('<li><a href="' + action + data + '">' +
    '<img src="img/' + icon + '" class="ui-li-icon"><h3>' + title + '</h3>' +
    '<p>' + data + '</p></a></li>');
}