var d = new Date();
var d2 = new Date();
var currentIndex = 1;
var departmentName = "";

$(document).on("pageshow", "#dschedule-page", function (event) {
    slider.setup();
	// disable swipe on footer to remain navigation
	$("#dschedule-footer").unbind('swipeleft swiperight');	
	//$('#lastPubScheduleDate').text(parseDateLong(lastPublishedSchedule));
	lastPublishedScheduleRequest($("#select-department").val());
	// datepicker on change
	$('#daily-date').on('change', function() {
	    d = fixTimeOffset($('#daily-date').datebox('getTheDate'));
	    setLoadingAll();
	    changeDate();
	});

	//$("#slider").on("swipe", swipeHandler);

});

//function swipeHandler(event) {
//    console.log("swiped!!!");
//}

$(document).on("pagecreate", "#dschedule-page", function(event) {				    
    var elem = document.getElementById('slider');
    window.slider = Swipe(elem, {        
		startSlide: 1,
		transitionEnd: function(index, elem) {	
			console.log(currentIndex+" "+index);
			var i = currentIndex - index;			

			if (i == 0)
			{
				// Not moved							
			}						
			else
			{				
				var other = 3 - (currentIndex + index);
			
				if (i == -1 || i == 2) // move right, to next day
				{	
					fixScheduleDate(d, 1);
					d2 = new Date(d);							
			    	d2 = fixScheduleDate(d2, 1);
			    				
				}
				else // move left, previous day
				{				
					fixScheduleDate(d, -1);
					d2 = new Date(d);							
			    	d2 = fixScheduleDate(d2, -1);				
				}
				
				// load new data in adjacent slide
		    	setLoading('#sc-' + other, parseDateLong(d2));	    				    
			    refreshSchedule(other, d2);		    
			    
			    currentIndex = index;						    	
			}						    								
		}
	});
	
    loadDiv('#sc-0', views + 'loading.html');
    loadDiv('#sc-1', views + 'loading.html');
    loadDiv('#sc-2', views + 'loading.html');
	       
    initDepartmentList();
    changeDate();
    
    $("#select-department").change(function(e) { 
    	window.localStorage.setItem("curDept", $(this).val());
        departmentName = $("#select-department option[value='" + $(this).val() + "']").text();
        console.log($(this).val());
        lastPublishedScheduleRequest($(this).val());
        setLoadingAll();
        // android bugfix
        setTimeout(function(){ changeDate(); }, 20 ); 
    });
    
    $("#prev-day").click(function() {
        console.log("prev"+slider);
        slider.prev();
    });
    
    $("#next-day").click(function() {
        slider.next();
    }); 
    
    $('#cal-icon').click(function() {
        // update the datebox' date to current
    	$('#daily-date').val(parseDate(d));
        $('#daily-date').datebox('open');
    });
    
    lastPublishedScheduleRequest($("#select-department").val());
});


function initDepartmentList() {
    for(i = 0; i < D.Departments.length; i++) {
         var curDept = D.Departments[i];
         var selected = curDept.DepartmentID == window.localStorage.getItem("curDept") ? " selected" : "";
         if(selected != "") { 
        	 departmentName = curDept.DE_Name;
        	 $("#select-dept-button").text(departmentName);
         }
         var options = "<option value='" + curDept.DepartmentID + "' " + selected + ">" + curDept.DE_Name + "</option>";
         $("select#select-department").append(options);
    }

    if(D.Departments.length <= 1) {    
        $("select#select-department").remove();
    }
    else {
    	$("select#select-department").selectmenu("refresh");
    }
       
}

function updateList(msg, title, targetSchedule) {
    $(targetSchedule + ' li').remove();
    if(title != null) {
    	$(targetSchedule).append('<li data-role="list-divider">' + title + '</li>');
    }
    $(targetSchedule).append('<li>' + msg + '</li>');
    $(targetSchedule).listview('refresh');
}

function setLoadingAll() {
    setLoading('#sc-0', null);
    setLoading('#sc-1', null);
    setLoading('#sc-2', null);
}

function setLoading(targetSchedule, scheduleTitle) {
    $.mobile.silentScroll(0);
    updateList('<img src="css/images/ajax-loader-small.gif" class="ui-li-icon">' +
                '<span class="paddLeft">Bezig met laden...</span>', scheduleTitle, targetSchedule);
}

function noScheduleFound(targetSchedule, scheduleTitle) {
    updateList('(nog) geen rooster beschikbaar', scheduleTitle, targetSchedule);
}

function refreshSchedule(targetNum, date) {
	console.log("load " + parseDateTimeFull(date) + " into sc-" + targetNum);
	getScheduleRequest(date.toJSON(), targetNum, window.localStorage.getItem("curDept"));
}

// set date with offset and fix time to 00:00
function fixScheduleDate(date, offset) {
	date.setDate(d.getDate() + offset);
    date = fixTimeOffset(date);
    return date;
}

/**
 * Change the date of the schedule to show
 */
function changeDate() {
	
	var prev = currentIndex - 1;
	if (prev < 0){
		prev = 2;
	}
		
	var next = currentIndex + 1;
	if (next > 2) {
		next = 0;
	}
	
	refreshSchedule(currentIndex, fixScheduleDate(d, 0));     
    refreshSchedule(next, fixScheduleDate(d2, 1));
    refreshSchedule(prev, fixScheduleDate(d2, -1));
    
    /*refreshSchedule(1, fixScheduleDate(d, 0)); 
    d2 = new Date(d);
    refreshSchedule(2, fixScheduleDate(d2, 1));
    refreshSchedule(0, fixScheduleDate(d2, -1));
    */
}

/**
 * Call webservice to get daily schedule
 */
function getScheduleRequest(date, targetNum, departmentId) {
    console.log("GET SCHEDULE " + date + " -> " + departmentId);
    var data = {
        "key" : D.Key,
        "departmentId" : departmentId,
        "date" : date
    };       
    
    return CallWCF('GetScheduleAndFrqMobile', data, "getScheduleResponse" + targetNum);
}

function getScheduleFailed(error, targetNum) {
    updateList('<img src="css/images/error.gif" class="ui-li-icon">' +
                '<span onClick="refreshSchedule()" class="paddLeft">' + error + ', probeer opnieuw</span>', targetSchedule);
}

/**
 * Called after WCF responds
 */
function getScheduleResponse(result, request, targetSchedule) {
	
	var scheduleTitle = "";
	console.log(request);
	if(request.date != null) {
		var dtStr = request.date.substr(0,10);
		dtStr = dtStr.split("-");
		var curDate = new Date(dtStr[0], dtStr[1]-1, dtStr[2]);
		scheduleTitle = parseDateLong(curDate);
	}
	
	console.log(request.date + " RECEIVED at " + targetSchedule);
	//console.log(JSON.stringify(result.d));
	
    if(result.d == null || result.d.length == 0) {
        noScheduleFound(targetSchedule, scheduleTitle);
    } else {
        $(targetSchedule + ' li').remove();
        $(targetSchedule).append('<li data-role="list-divider">' + scheduleTitle + '</li>');

        $.each(result.d, function(index, Shift) {
            var curEmployee = D.Employees[Shift.EmployeeID];                      
            curEmployee = curEmployee == null ? "" : curEmployee.EM_FirstName + ' ' + curEmployee.EM_LastName;
            $.each(Shift.ShiftItems, function(index, ShiftItem) {         
                 var beginTime = getDateFromJSON(ShiftItem.SH_BeginTime);
                 var endTime = getDateFromJSON(ShiftItem.SH_EndTime);
                 
                 var isFree = false;
                 var frType = "";
                
                 if (Shift.FreeRequest != null)
                 {                     
                    var frBegin = getDateFromJSON(Shift.FreeRequest.FR_BeginTime);                     

                    var frEnd;
                 	if (Shift.FreeRequest.FR_EndTime == null || Shift.FreeRequest.FR_EndTime == undefined)
                 	{
                 	    frEnd = new Date(curDate);                 	    
                 	    frEnd.setDate(curDate.getDate() + 100);            		    
            		}
                 	else
            		{
                        frEnd = getDateFromJSON(Shift.FreeRequest.FR_EndTime);
            		}

            		if(!(frEnd < beginTime || frBegin > endTime))
		            {		        
		            	isFree = true;       
		                frType = getFrType(Shift.FreeRequest.FreeRequestTypeID);                              
		            }
            	 }
                
                

                 addDScheduleShiftItem(targetSchedule, Shift.EmployeeID, curEmployee, beginTime, endTime, ShiftItem.Function, Shift.EmployeeID == D.Employee.EmployeeID, isFree, frType);
             });
             
            if (curEmployee == "" && Shift.EmployeeID != "00000000-0000-0000-0000-000000000000")
           	{
           		$.jsonp({
		            url : ServiceURL + "GetEmployeeById",
		            callbackParameter : "callback",
		            data : { "key" : D.Key, "employeeId" : Shift.EmployeeID },
		            timeout: 10000,
		            success : function(data, text) {
		            	var emp = data.d;
		            	$("." + emp.EmployeeID).text(emp.EM_FirstName + ' ' + emp.EM_LastName);
		            	//console.log(emp.EM_FirstName);
		            	//curEmployee = emp;		                                 		               		          
		            },
		            error : function(request, status) {
		                // Employee not found
		            }		           		           
		        });           				           	
           	}
        });
        $(targetSchedule).listview('refresh');
    }
}

function addDScheduleShiftItem(targetSchedule, employeeId, employeeName, beginTime, endTime, functionItem, isUser, isFree, frType) {
    var liClass = isUser ? 'smallerPadding ui-btn-active' : 'smallerPadding';    
    var liItem = '<li class="' + liClass + '"><div class="ui-grid-b mediumText"><div class="ui-block-a">' + parseShiftTimes(beginTime, endTime) + '</div>';
    	if (isFree) {
    	    var frColor = isUser ? '#15428b' : '#15428b';
    	    liItem += '<div class="ui-block-b w50pt truncate ' + employeeId + '"><span style="color:' + intToHexColor(frType.FRT_ColorInt) + ';text-decoration:line-through"><span style="color: ' + frColor +'">' + employeeName + '</span></span>' + 
    	    '<font style="-webkit-text-stroke: 0.5px black;" color="' + intToHexColor(frType.FRT_ColorInt) + '"> ' + frType.FRT_Name.substring(0,1) + '</font></div>';
	    }
	    else {
	       	liItem += '<div class="ui-block-b w50pt truncate ' + employeeId + '">'  + employeeName + '</div>';
	    }	    
    liItem += '<div class="ui-block-c w20pt"><span class="employee-function" style="background-color: ' + intToHexColor(functionItem.FN_Color) + '">' + functionItem.FN_ShortName + '</div></span></li>';
    
    $(targetSchedule).append(liItem);
}

/* SUBMETHODS */

function getScheduleResponse0(res, rq) {
	return getScheduleResponse(res, rq, "#sc-0");
}

function getScheduleResponse1(res, rq) {
	return getScheduleResponse(res, rq, "#sc-1");
}

function getScheduleResponse2(res, rq) {
	return getScheduleResponse(res, rq, "#sc-2");
}
