var NewsItems = null;
var curNewsItem = 0;


$(document).on("pagecreate", "#news-page", function(event) {	
    loadNews();
});

function showNewsItem(id) {
	curNewsItem = id;		
	$("body").pagecontainer("change", "newsitem.html", { allowSamePageTransition: true, transition: "slide" });
	//$("#news-content").pagecontainer("change", "newsitem.html", { allowSamePageTransition: true });	 
	console.log("shownewsitem");  	
}

function loadNews() {
    $('#news-title').children('h2').text(D.Company + " - nieuws");
    loadDiv('#news-list', views + 'loading.html');
    getNewsRequest();
}

/**
 * Call webservice to get news
 */
function getNewsRequest() {	 
    var data = {
        "key" : D.Key,
        "employeeId" : D.Employee.EmployeeID,
        "locationId" : D.Employee.LocationID
    };

    return CallWCF('GetNews', data, "getNewsResponse");
}

/**
 * Called after WCF responds
 */
function getNewsResponse(result) {    
    $('#news-list li').remove();    
    if(result.d == null || result.d.length == 0) {
        $('#news-list').append('<li>momenteel geen nieuws beschikbaar</li>');
    } else {
    	  NewsItems = result.d;        
        $.each(NewsItems, function(index, newsItem) {
        	if(newsItem.NW_Subject == null) newsItem.NW_Subject = "";
            newsItem.NW_Subject = newsItem.NW_Subject.replace("|||", "");             
            addNewsItem(index, newsItem);
        });
    }
    $('#news-list').listview('refresh');
    //$("news-list").trigger("create");
}

//<a href="javascript:void(0);" onClick="showNewsItem(' + index + ');">

function addNewsItem(index, newsItem) {	 
    $('#news-list').append('<li><a href="javascript:void(0);" onClick="showNewsItem(' + index + ');"><h2>' + newsItem.NW_Subject +
    '</h2><p>' + strip_html(html_decode(newsItem.NW_Content)) + '</p>' +
    '<div class="gray right tinyText">' + parseDateLong(getDateFromJSON(newsItem.NW_BeginDate)) + '</div></a></li>');
}

/**
 * Called on opening a news item
 */
    
$(document).on("pagebeforeshow", "#newsitem", function(event) {
    //var id = getUrlVars()["id"];
    var newsItem = NewsItems[curNewsItem];
    if(newsItem != null) {
        if(newsItem.NW_Author == null) newsItem.NW_Author = "Beheerder";
        
        var newsItemDate = "Geplaatst: " + parseDateLong(getDateFromJSON(newsItem.NW_BeginDate));
        var newsItemAuthor = "Door: " + newsItem.NW_Author;
        
       // $('#newsitem-title').children('h2').text(getCompanyName() + " - nieuws");
        $('#newsitem-contentdiv div.iscroll-scroller div.iscroll-content').children('h3').text(newsItem.NW_Subject);
        //$('#newsitem-contentdiv').children('h5').text(newsItemDate);
        //$('#newsitem-contentdiv').children('h6').text(newsItemAuthor);
        $('#newsitem-contentdiv div.iscroll-scroller div.iscroll-content').children('p').html(parseURL(parseImgFix(html_decode(newsItem.NW_Content))));
        $('#newsitem-footer').html(newsItemDate + " " + newsItemAuthor);
    }
});

$(document).on("pageinit", "#newsitem", function () {    
    $("#newsitem-contentdiv").data("mobileIscrollview").resizeWrapper();
    $("#newsitem-contentdiv").data("mobileIscrollview").refresh();
});
