
$(document).on("pagecreate", "#login-page", function(event) {
	var login = window.localStorage.getItem("login");	
	if(login != null) {
        setTimeout(setLogin, 800, login);
      // setLogin(login);
    }    
});

function tryLogin() {
	if($('#UserName').val() == "" || $('#Password').val() == "")
	    //alert("Vul je e-mailadres en wachtwoord in");
	    showNotification("Inloggen", "Vul je e-mailadres en wachtwoord in");
	else
	    setLogin(encode($('#UserName').val() + "|" + $('#Password').val()));
};

function setLogin(loginkey) {	
	$.mobile.loading( "show", {
	  text: "Bezig met inloggen..",
	  textVisible: true,
	  theme: "b",
	  html: ""
	});   
    loginRequest(loginkey);
}

/**
 * Make login attempt at the webservice
 * @param email
 * @param password
 */
function loginRequest(loginkey) {
    var deviceInfo = "";
    if(!(typeof device === 'undefined')) {
        deviceInfo = device.platform + " " + device.version + " (" + device.name + ")";
    }
    
    var data = { "loginkey" : loginkey, "deviceInfo" : deviceInfo };   
    return CallWCF('GetUserApp', data, "loginResponse");
}

/**
 * Called after WCF responds
 */
function loginResponse(result) {
    if(result == null) {
        alert('FAILED');
    }    
    else if(result.d == null || result.d.Error != null) {
    console.log(result);
        //alert('Inloggen mislukt');
        showNotification("Inloggen mislukt", "E-mail/wachtwoord onjuist");     
    } else {
       D = result.d;
       if(D.Settings == null) D.Settings = {};
       saveEmployees(result.d.Employees);
       getFRinitRequest();
       
       if(window.localStorage.getItem("curDept") == null && D.Departments.length > 0)
            window.localStorage.setItem("curDept", D.Departments[0].DepartmentID);
        
        if($("input[name='RememberMe']").is(":checked")){        
            var loginkey = encode($("#UserName").val() + "|" + $("#Password").val());
            window.localStorage.setItem("login", loginkey);
        }
        console.log("Login success")
        $(":mobile-pagecontainer").pagecontainer("change", "news.html", { allowSamePageTransition: true });    
    }
    hideLoading();
}

function saveEmployees(e) {
    D.Employees = {};
    var currentEmp = null;
    for(var i = 0; i < e.length; i++) {
        currentEmp = e[i];
        D.Employees[currentEmp.EmployeeID] = currentEmp;
    }
}

function getFRinitRequest() {
    var data = { "key" : D.Key };
    return CallWCF('GetFreeRequestsEmployee', data, "getFRinitResponse");
}

function getFRinitResponse(result) {
    FreeRequests = result.d;
}

/**
 * Logout and return to login screen
 */
function logout() {
 //   console.log("logout");
    window.localStorage.clear();
    $(":mobile-pagecontainer").pagecontainer("change", "login.html", { allowSamePageTransition: true });        
}

